Index: wp-includes/css/editor.dev.css
===================================================================
--- wp-includes/css/editor.dev.css	(revision 20398)
+++ wp-includes/css/editor.dev.css	(working copy)
@@ -98,7 +98,7 @@
 
 .wp_themeSkin .mceStatusbar {
 	display: block;
-	font-family: Arial, "Bitstream Vera Sans", Helvetica, Verdana, sans-serif;
+	font-family: sans-serif;
 	font-size: 12px;
 	line-height: 16px;
 	padding: 0 0 0 8px;
@@ -147,6 +147,11 @@
 	margin: 0 6px 2px;
 }
 
+.wp_themeSkin table.mceToolbar:focus,
+.wp_themeSkin span.mceSeparator:focus {
+	outline: none;
+}
+
 .wp_themeSkin #content_toolbar1 {
 	margin-top: 2px;
 }
@@ -176,9 +181,6 @@
 	margin: 1px;
 	-webkit-border-radius: 2px;
 	border-radius: 2px;
-	-webkit-box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-	-moz-box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-	box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
 }
 
 .wp_themeSkin a.mceButtonEnabled:hover {
@@ -189,18 +191,9 @@
 	margin: 0 0 0 1px;
 }
 
-.wp_themeSkin a.mceButton:active,
-.wp_themeSkin a.mceButtonActive,
-.wp_themeSkin a.mceButtonActive:hover,
-.wp_themeSkin a.mceButtonSelected {
-	-webkit-box-shadow:	 0 1px 1px rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-	-moz-box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-	box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-}
-
 .wp_themeSkin .mceButtonDisabled .mceIcon {
-	opacity: 0.5;
-	filter: alpha(opacity=50);
+	opacity: 0.4;
+	filter: alpha(opacity=40);
 }
 
 /* Separator */
@@ -228,10 +221,7 @@
 	-webkit-border-top-left-radius: 2px;
 	border-bottom-left-radius: 2px;
 	border-top-left-radius: 2px;
-	-webkit-box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-	-moz-box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-	box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-	font-family: Arial, "Bitstream Vera Sans", Helvetica, Verdana, sans-serif;
+	font-family: sans-serif;
 	font-size: 12px;
 	height: 20px;
 	line-height: 20px;
@@ -252,9 +242,6 @@
 	-webkit-border-top-left-radius: 0;
 	border-bottom-left-radius: 0;
 	border-top-left-radius: 0;
-	-webkit-box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-	-moz-box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-	box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
 }
 
 .wp_themeSkin .mceListBox .mceOpen span {
@@ -289,7 +276,7 @@
 }
 
 .wp_themeSkin select.mceListBox {
-	font-family: Arial, "Bitstream Vera Sans", Helvetica, Verdana, sans-serif;
+	font-family: sans-serif;
 	font-size: 12px;
 	border-color: #B2B2B2;
 	background-color: #fff;
@@ -314,12 +301,6 @@
 	border-radius: 2px;
 }
 
-.wp_themeSkin table.mceSplitButton td a {
-	-webkit-box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-	-moz-box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-	box-shadow: 0 1px 0 rgba(0, 0, 0, 0.15), inset 0 0 2px 1px #fff;
-}
-
 .wp_themeSkin table.mceSplitButton:hover td {
 	background-image: inherit 0 -10px;
 }
@@ -413,7 +394,7 @@
 /* ColorSplitButton */
 .wp_themeSkin div.mceColorSplitMenu table {
 	background-color: #ebebeb;
-	border-color: #B2B2B2;
+	border-color: #bbb;
 }
 
 .wp_themeSkin .mceColorSplitMenu td {
@@ -425,7 +406,7 @@
 	width: 9px;
 	height: 9px;
 	overflow: hidden;
-	border-color: #B2B2B2;
+	border-color: #bbb;
 }
 
 .wp_themeSkin .mceColorSplitMenu td.mceMoreColors {
@@ -852,17 +833,17 @@
 .wp_themeSkin .mceListBox .mceText,
 .wp_themeSkin .mceListBox .mceOpen {
 	border-color: #ccc;
-	background-color: #eee; /* Fallback */
-	background-image: -ms-linear-gradient(bottom, #ddd, #fff); /* IE10 */
-	background-image: -moz-linear-gradient(bottom, #ddd, #fff); /* Firefox */
-	background-image: -o-linear-gradient(bottom, #ddd, #fff); /* Opera */
-	background-image: -webkit-gradient(linear, left bottom, left top, from(#ddd), to(#fff)); /* old Webkit */
-	background-image: -webkit-linear-gradient(bottom, #ddd, #fff); /* new Webkit */
-	background-image: linear-gradient(bottom, #ddd, #fff); /* proposed W3C Markup */
+	background: #ddd; /* Fallback */
+	background-image: -ms-linear-gradient(bottom, #ccc, #efefef); /* IE10 */
+	background-image: -moz-linear-gradient(bottom, #ccc, #efefef); /* Firefox */
+	background-image: -o-linear-gradient(bottom, #ccc, #efefef); /* Opera */
+	background-image: -webkit-gradient(linear, left bottom, left top, from(#ccc), to(#efefef)); /* old Webkit */
+	background-image: -webkit-linear-gradient(bottom, #ccc, #efefef); /* new Webkit */
+	background-image: linear-gradient(bottom, #ccc, #efefef); /* proposed W3C Markup */
 }
 
 .wp_themeSkin a.mceButtonEnabled:hover {
-	border-color: #a0a0a0;
+	border-color: #aaa;
 	background: #ddd; /* Fallback */
 	background-image: -ms-linear-gradient(bottom, #ccc, #fff); /* IE10 */
 	background-image: -moz-linear-gradient(bottom, #ccc, #fff); /* Firefox */
@@ -879,17 +860,19 @@
 .wp_themeSkin a.mceButtonActive:active,
 .wp_themeSkin a.mceButtonActive:hover {
 	background-color: #ddd; /* Fallback */
-	background-image: -ms-linear-gradient(bottom, #eee, #bbb); /* IE10 */
-	background-image: -moz-linear-gradient(bottom, #eee, #bbb); /* Firefox */
-	background-image: -o-linear-gradient(bottom, #eee, #bbb); /* Opera */
-	background-image: -webkit-gradient(linear, left bottom, left top, from(#eee), to(#bbb)); /* old Webkit */
-	background-image: -webkit-linear-gradient(bottom, #eee, #bbb); /* new Webkit */
-	background-image: linear-gradient(bottom, #eee, #bbb); /* proposed W3C Markup */
-	border-color: #909090;
+	background-image: -ms-linear-gradient(bottom, #efefef, #ccc); /* IE10 */
+	background-image: -moz-linear-gradient(bottom, #efefef, #ccc); /* Firefox */
+	background-image: -o-linear-gradient(bottom, #efefef, #ccc); /* Opera */
+	background-image: -webkit-gradient(linear, left bottom, left top, from(#efefef), to(#ccc)); /* old Webkit */
+	background-image: -webkit-linear-gradient(bottom, #efefef, #ccc); /* new Webkit */
+	background-image: linear-gradient(bottom, #efefef, #ccc); /* proposed W3C Markup */
+	border-color: #aaa;
 }
 
 .wp_themeSkin .mceButtonDisabled {
-	border-color: #ccc !important;
+	border-color: transparent !important;
+	background: transparent;
+	background-image: none;
 }
 
 .wp_themeSkin .mceListBox .mceOpen {
@@ -903,14 +886,14 @@
 .wp_themeSkin .mceListBoxSelected .mceText,
 .wp_themeSkin table.mceListBoxEnabled:active .mceText {
 	background: #ccc;
-	border-color: #999;
+	border-color: #aaa;
 }
 
 .wp_themeSkin table.mceListBoxEnabled:hover .mceText,
 .wp_themeSkin .mceListBoxHover .mceText,
 .wp_themeSkin table.mceListBoxEnabled:hover .mceOpen,
 .wp_themeSkin .mceListBoxHover .mceOpen {
-	border-color: #909090;
+	border-color: #aaa;
 	background-color: #eee; /* Fallback */
 	background-image: -ms-linear-gradient(bottom, #ccc, #fff); /* IE10 */
 	background-image: -moz-linear-gradient(bottom, #ccc, #fff); /* Firefox */
@@ -930,17 +913,21 @@
 .wp_themeSkin .mceSplitButtonSelected a.mceOpen,
 .wp_themeSkin table.mceSplitButtonEnabled:hover a.mceAction,
 .wp_themeSkin .mceSplitButton a.mceAction:hover {
-	border-color: #909090;
+	border-color: #aaa;
 }
 
+.wp_themeSkin .mceSplitButtonSelected a.mceOpen {
+	background-color: #aaa;
+}
+
 .wp_themeSkin table.mceSplitButton td {
-	background-color: #eee; /* Fallback */
-	background-image: -ms-linear-gradient(bottom, #ddd, #fff); /* IE10 */
-	background-image: -moz-linear-gradient(bottom, #ddd, #fff); /* Firefox */
-	background-image: -o-linear-gradient(bottom, #ddd, #fff); /* Opera */
-	background-image: -webkit-gradient(linear, left bottom, left top, from(#ddd), to(#fff)); /* old Webkit */
-	background-image: -webkit-linear-gradient(bottom, #ddd, #fff); /* new Webkit */
-	background-image: linear-gradient(bottom, #ddd, #fff); /* proposed W3C Markup */
+	background: #ddd; /* Fallback */
+	background-image: -ms-linear-gradient(bottom, #ccc, #efefef); /* IE10 */
+	background-image: -moz-linear-gradient(bottom, #ccc, #efefef); /* Firefox */
+	background-image: -o-linear-gradient(bottom, #ccc, #efefef); /* Opera */
+	background-image: -webkit-gradient(linear, left bottom, left top, from(#ccc), to(#efefef)); /* old Webkit */
+	background-image: -webkit-linear-gradient(bottom, #ccc, #efefef); /* new Webkit */
+	background-image: linear-gradient(bottom, #ccc, #efefef); /* proposed W3C Markup */
 }
 
 .wp_themeSkin table.mceSplitButton:hover td {
Index: wp-admin/css/colors-classic.dev.css
===================================================================
--- wp-admin/css/colors-classic.dev.css	(revision 20398)
+++ wp-admin/css/colors-classic.dev.css	(working copy)
@@ -884,6 +884,7 @@
 }
 
 /* Containers */
+.wp-editor-wrap .wp-editor-container,
 .wp-editor-wrap .wp_themeSkin table.mceLayout {
 	border-color: #bed1dd #bed1dd #d0dfe9;
 }
@@ -905,26 +906,28 @@
 }
 
 /* Button */
-.wp-editor-wrap .wp_themeSkin .mceButton {
-	border-color: #B0C8D7;
-	background-color: #cfdfe9; /* Fallback */
-	background-image: -ms-linear-gradient(bottom, #cfdfe9, #fff); /* IE10 */
-	background-image: -moz-linear-gradient(bottom, #cfdfe9, #fff); /* Firefox */
-	background-image: -o-linear-gradient(bottom, #cfdfe9, #fff); /* Opera */
-	background-image: -webkit-gradient(linear, left bottom, left top, from(#cfdfe9), to(#fff)); /* old Webkit	*/
-	background-image: -webkit-linear-gradient(bottom, #cfdfe9, #fff) !important; /* new Webkit */
-	background-image: linear-gradient(bottom, #cfdfe9, #fff); /* proposed W3C Markup */
+.wp-editor-wrap .wp_themeSkin .mceButton,
+.wp-editor-wrap .wp_themeSkin .mceListBox .mceText,
+.wp-editor-wrap .wp_themeSkin .mceListBox .mceOpen {
+	border-color: #c7d8e2 !important;
+	background-color: #c7d8e2; /* Fallback */
+	background-image: -ms-linear-gradient(bottom, #cfdfe9, #f2f6f9); /* IE10 */
+	background-image: -moz-linear-gradient(bottom, #cfdfe9, #f2f6f9); /* Firefox */
+	background-image: -o-linear-gradient(bottom, #cfdfe9, #f2f6f9); /* Opera */
+	background-image: -webkit-gradient(linear, left bottom, left top, from(#cfdfe9), to(#f2f6f9)); /* old Webkit	*/
+	background-image: -webkit-linear-gradient(bottom, #cfdfe9, #f2f6f9) !important; /* new Webkit */
+	background-image: linear-gradient(bottom, #cfdfe9, #f2f6f9); /* proposed W3C Markup */
 }
 
 .wp-editor-wrap .wp_themeSkin a.mceButtonEnabled:hover {
-	border-color: #5589AA !important;
-	background-color: #c9c9c9; /* Fallback */
-	background-image: -ms-linear-gradient(bottom, #bdccd5, #fff); /* IE10 */
-	background-image: -moz-linear-gradient(bottom, #bdccd5, #fff); /* Firefox */
-	background-image: -o-linear-gradient(bottom, #bdccd5, #fff); /* Opera */
-	background-image: -webkit-gradient(linear, left bottom, left top, from(#bdccd5), to(#fff)); /* old Webkit	 */
-	background-image: -webkit-linear-gradient(bottom, #bdccd5, #fff) !important; /* new Webkit */
-	background-image: linear-gradient(bottom, #bdccd5, #fff); /* proposed W3C Markup */
+	border-color: #99b8cc !important;
+	background-color: #c7d8e2; /* Fallback */
+	background-image: -ms-linear-gradient(bottom, #dbe7ee, #fff); /* IE10 */
+	background-image: -moz-linear-gradient(bottom, #dbe7ee, #fff); /* Firefox */
+	background-image: -o-linear-gradient(bottom, #dbe7ee, #fff); /* Opera */
+	background-image: -webkit-gradient(linear, left bottom, left top, from(#dbe7ee), to(#fff)); /* old Webkit	*/
+	background-image: -webkit-linear-gradient(bottom, #dbe7ee, #fff) !important; /* new Webkit */
+	background-image: linear-gradient(bottom, #dbe7ee, #fff); /* proposed W3C Markup */
 }
 
 .wp-editor-wrap .wp_themeSkin a.mceButton:active,
@@ -933,33 +936,23 @@
 .wp-editor-wrap .wp_themeSkin a.mceButtonActive,
 .wp-editor-wrap .wp_themeSkin a.mceButtonActive:active,
 .wp-editor-wrap .wp_themeSkin a.mceButtonActive:hover {
-	background: #B0C8D7 !important;
-	background-image: -ms-linear-gradient(bottom, #fff, #cfdfe9); /* IE10 */
-	background-image: -moz-linear-gradient(bottom, #fff, #cfdfe9); /* Firefox */
-	background-image: -o-linear-gradient(bottom, #fff, #cfdfe9); /* Opera */
-	background-image: -webkit-gradient(linear, left bottom, left top, from(#fff), to(#cfdfe9)); /* old Webkit	 */
-	background-image: -webkit-linear-gradient(bottom, #fff, #cfdfe9) !important; /* new Webkit */
-	background-image: linear-gradient(bottom, #fff, #cfdfe9); /* proposed W3C Markup */
-	border-color: #5589AA !important;
+	background: #c7d8e2; /* Fallback */
+	background-image: -ms-linear-gradient(bottom, #f2f6f9, #cfdfe9); /* IE10 */
+	background-image: -moz-linear-gradient(bottom, #f2f6f9, #cfdfe9); /* Firefox */
+	background-image: -o-linear-gradient(bottom, #f2f6f9, #cfdfe9); /* Opera */
+	background-image: -webkit-gradient(linear, left bottom, left top, from(#f2f6f9), to(#cfdfe9)); /* old Webkit	 */
+	background-image: -webkit-linear-gradient(bottom, #f2f6f9, #cfdfe9) !important; /* new Webkit */
+	background-image: linear-gradient(bottom, #f2f6f9, #cfdfe9); /* proposed W3C Markup */
+	border-color: #99b8cc !important;
 }
 
 .wp-editor-wrap .wp_themeSkin .mceButtonDisabled {
-	border-color: #B0C8D7 !important;
+	border-color: transparent !important;
+	background: transparent;
+	background-image: none;
 }
 
 /* ListBox */
-.wp-editor-wrap .wp_themeSkin .mceListBox .mceText,
-.wp-editor-wrap .wp_themeSkin .mceListBox .mceOpen	{
-	border-color: #B0C8D7;
-	background-color: #cfdfe9; /* Fallback */
-	background-image: -ms-linear-gradient(bottom, #cfdfe9, #fff); /* IE10 */
-	background-image: -moz-linear-gradient(bottom, #cfdfe9, #fff); /* Firefox */
-	background-image: -o-linear-gradient(bottom, #cfdfe9, #fff); /* Opera */
-	background-image: -webkit-gradient(linear, left bottom, left top, from(#cfdfe9), to(#fff)); /* old Webkit	*/
-	background-image: -webkit-linear-gradient(bottom, #cfdfe9, #fff) !important; /* new Webkit */
-	background-image: linear-gradient(bottom, #cfdfe9, #fff); /* proposed W3C Markup */
-}
-
 .wp-editor-wrap .wp_themeSkin .mceListBox .mceOpen {
 	border-left: 0px !important;
 }
@@ -970,8 +963,8 @@
 .wp-editor-wrap .wp_themeSkin .mceListBoxSelected .mceOpen,
 .wp-editor-wrap .wp_themeSkin .mceListBoxSelected .mceText,
 .wp-editor-wrap .wp_themeSkin table.mceListBoxEnabled:active .mceText {
-	background: #B0C8D7;
-	border-color: #5589AA !important;
+	background: #c7d8e2;
+	border-color: #99b8cc !important;
 }
 
 /* List Box Hover */
@@ -979,14 +972,14 @@
 .wp-editor-wrap .wp_themeSkin .mceListBoxHover .mceText,
 .wp-editor-wrap .wp_themeSkin table.mceListBoxEnabled:hover .mceOpen,
 .wp-editor-wrap .wp_themeSkin .mceListBoxHover .mceOpen {
-	border-color: #5589AA !important;
-	background-color: #c9c9c9; /* Fallback */
-	background-image: -ms-linear-gradient(bottom, #cfdfe9, #fff); /* IE10 */
-	background-image: -moz-linear-gradient(bottom, #cfdfe9, #fff); /* Firefox */
-	background-image: -o-linear-gradient(bottom, #cfdfe9, #fff); /* Opera */
-	background-image: -webkit-gradient(linear, left bottom, left top, from(#cfdfe9), to(#fff)); /* old Webkit	*/
-	background-image: -webkit-linear-gradient(bottom, #cfdfe9, #fff) !important; /* new Webkit */
-	background-image: linear-gradient(bottom, #cfdfe9, #fff); /* proposed W3C Markup */
+	border-color: #99b8cc !important;
+	background-color: #c7d8e2; /* Fallback */
+	background-image: -ms-linear-gradient(bottom, #dbe7ee, #fff); /* IE10 */
+	background-image: -moz-linear-gradient(bottom, #dbe7ee, #fff); /* Firefox */
+	background-image: -o-linear-gradient(bottom, #dbe7ee, #fff); /* Opera */
+	background-image: -webkit-gradient(linear, left bottom, left top, from(#dbe7ee), to(#fff)); /* old Webkit	*/
+	background-image: -webkit-linear-gradient(bottom, #dbe7ee, #fff) !important; /* new Webkit */
+	background-image: linear-gradient(bottom, #dbe7ee, #fff); /* proposed W3C Markup */
 }
 
 .wp-editor-wrap .wp_themeSkin select.mceListBox {
@@ -995,41 +988,46 @@
 }
 
 /* SplitButton */
-.wp-editor-wrap .wp_themeSkin .mceSplitButton a.mceAction,
-.wp-editor-wrap .wp_themeSkin .mceSplitButton a.mceOpen {
-	border-color: #B0C8D7;
+.wp-editor-wrap .wp_themeSkin table.mceSplitButton td {
+	border-color: #c7d8e2 !important;
+	background-color: #c7d8e2; /* Fallback */
+	background-image: -ms-linear-gradient(bottom, #cfdfe9, #f2f6f9); /* IE10 */
+	background-image: -moz-linear-gradient(bottom, #cfdfe9, #f2f6f9); /* Firefox */
+	background-image: -o-linear-gradient(bottom, #cfdfe9, #f2f6f9); /* Opera */
+	background-image: -webkit-gradient(linear, left bottom, left top, from(#cfdfe9), to(#f2f6f9)); /* old Webkit	*/
+	background-image: -webkit-linear-gradient(bottom, #cfdfe9, #f2f6f9) !important; /* new Webkit */
+	background-image: linear-gradient(bottom, #cfdfe9, #f2f6f9); /* proposed W3C Markup */
 }
 
 .wp-editor-wrap .wp_themeSkin .mceSplitButton a.mceOpen:hover,
 .wp-editor-wrap .wp_themeSkin .mceSplitButtonSelected a.mceOpen,
 .wp-editor-wrap .wp_themeSkin table.mceSplitButtonEnabled:hover a.mceAction,
 .wp-editor-wrap .wp_themeSkin .mceSplitButton a.mceAction:hover {
-	border-color: #5589AA !important;
+	border-color: #99b8cc !important;
 }
 
-.wp-editor-wrap .wp_themeSkin table.mceSplitButton td {
-	background-color: #cfdfe9; /* Fallback */
-	background-image: -ms-linear-gradient(bottom, #cfdfe9, #fff); /* IE10 */
-	background-image: -moz-linear-gradient(bottom, #cfdfe9, #fff); /* Firefox */
-	background-image: -o-linear-gradient(bottom, #cfdfe9, #fff); /* Opera */
-	background-image: -webkit-gradient(linear, left bottom, left top, from(#cfdfe9), to(#fff)); /* old Webkit	*/
-	background-image: -webkit-linear-gradient(bottom, #cfdfe9, #fff) !important; /* new Webkit */
-	background-image: linear-gradient(bottom, #cfdfe9, #fff); /* proposed W3C Markup */
+.wp-editor-wrap .wp_themeSkin table.mceSplitButton:hover td {
+	background-image: -ms-linear-gradient(bottom, #dbe7ee, #fff); /* IE10 */
+	background-image: -moz-linear-gradient(bottom, #dbe7ee, #fff); /* Firefox */
+	background-image: -o-linear-gradient(bottom, #dbe7ee, #fff); /* Opera */
+	background-image: -webkit-gradient(linear, left bottom, left top, from(#dbe7ee), to(#fff)); /* old Webkit	*/
+	background-image: -webkit-linear-gradient(bottom, #dbe7ee, #fff) !important; /* new Webkit */
+	background-image: linear-gradient(bottom, #dbe7ee, #fff); /* proposed W3C Markup */
 }
 
-.wp-editor-wrap .wp_themeSkin table.mceSplitButton:hover td {
-	background-image: -ms-linear-gradient(bottom, #cfdfe9, #fff); /* IE10 */
-	background-image: -moz-linear-gradient(bottom, #cfdfe9, #fff); /* Firefox */
-	background-image: -o-linear-gradient(bottom, #cfdfe9, #fff); /* Opera */
-	background-image: -webkit-gradient(linear, left bottom, left top, from(#cfdfe9), to(#fff)); /* old Webkit	*/
-	background-image: -webkit-linear-gradient(bottom, #cfdfe9, #fff) !important; /* new Webkit */
-	background-image: linear-gradient(bottom, #cfdfe9, #fff); /* proposed W3C Markup */
+.wp-editor-wrap .wp_themeSkin .mceSplitButton a.mceAction,
+.wp-editor-wrap .wp_themeSkin .mceSplitButton a.mceOpen {
+	border-color: #c7d8e2;
 }
 
 .wp-editor-wrap .wp_themeSkin .mceSplitButtonActive {
-	background-color: #B0C8D7;
+	background-color: #99b8cc;
 }
 
+.wp-editor-wrap .wp_themeSkin .mceSplitButtonSelected a.mceOpen {
+	background-color: #99b8cc;
+}
+
 /* ColorSplitButton */
 .wp-editor-wrap .wp_themeSkin div.mceColorSplitMenu table {
 	background-color: #ebebeb;
@@ -1085,7 +1083,13 @@
 }
 
 .wp-editor-wrap .wp_themeSkin tr.mceFirst td.mceToolbar {
-	background: #cfdfe9 url("../images/ed-bg-vs.gif?ver=20101102") repeat-x scroll left top;
+	background-color: #eff8ff; /* Fallback */
+	background-image: -ms-linear-gradient(top, #eff8ff, #e0eff9); /* IE10 */
+	background-image: -moz-linear-gradient(top, #eff8ff, #e0eff9); /* Firefox */
+	background-image: -o-linear-gradient(top, #eff8ff, #e0eff9); /* Opera */
+	background-image: -webkit-gradient(linear, left top, left bottom, from(#eff8ff), to(#e0eff9)); /* old Webkit */
+	background-image: -webkit-linear-gradient(top, #eff8ff, #e0eff9); /* new Webkit */
+	background-image: linear-gradient(top, #eff8ff, #e0eff9); /* proposed W3C Markup */
 	border-color: #cfdfe9;
 }
 